Index: src/edu/ucsb/nceas/metacat/DocumentImpl.java
===================================================================
--- src/edu/ucsb/nceas/metacat/DocumentImpl.java	(revision 1216)
+++ src/edu/ucsb/nceas/metacat/DocumentImpl.java	(revision 1217)
@@ -1581,70 +1635,8 @@
     MetaCatUtil.debugMessage("action: " + action + " servercode: " + 
                              serverCode, 10);
                         
-    /*if((serverCode != 1 && action.equals("UPDATE")) )
-    { 
-      int istreamInt; 
-      char istreamChar;
-      DocumentIdentifier id = new DocumentIdentifier(accnum);
-      String updaterev = id.getRev();
-      String server = MetacatReplication.getServer(serverCode);
-      MetacatReplication.replLog("attempting to lock " + accnum);
-      URL u = new URL("https://" + server + "?server="
-           +util.getLocalReplicationServerName()+"&action=getlock&updaterev=" 
-           +updaterev + "&docid=" + docid);
-     
-      String serverResStr = MetacatReplication.getURLContent(u);
-      String openingtag =serverResStr.substring(0, serverResStr.indexOf(">")+1);
-      if(openingtag.equals("<lockgranted>"))
-      {
-        try 
-        {
-          
-          MetacatReplication.replLog("lock granted for " + accnum + " from " +
-                                      server);
-          XMLReader parser = initializeParser(conn, action, docid, updaterev,
-                                  validate, user, groups, pub, serverCode, dtd);
-          conn.setAutoCommit(false);
-          parser.parse(new InputSource(xml)); 
-          conn.commit();
-          conn.setAutoCommit(true);
-        } 
-        catch (Exception e) 
-        {
-          conn.rollback();
-          conn.setAutoCommit(true);
-          throw e;
-        }
-        return (accnum);
-      }
+  
 
-      else if(openingtag.equals("<filelocked>"))
-      {
-        MetacatReplication.replLog("lock denied for " + accnum + " on " +
-                                   server + " reason: file already locked");
-        throw new Exception("The file specified is already locked by another " +
-                            "user.  Please wait 30 seconds, checkout the " +
-                            "newer document, merge your changes and try " +
-                            "again.");
-      }
-      else if(openingtag.equals("<outdatedfile>"))
-      {
-        MetacatReplication.replLog("lock denied for " + accnum + " on " +
-                                    server + " reason: local file outdated");
-        throw new Exception("The file you are trying to update is an outdated" +
-                            " version.  Please checkout the newest document, " +
-                            "merge your changes and try again.");
-      }
-    }*/
-    
-    /*if ( action.equals("UPDATE") ) {
-      
-      if ( !hasPermission(conn, user, groups, docid) ) {
-        throw new Exception("User " + user + 
-              " does not have permission to update XML Document #" + accnum);
-      }          
-    }*/
-
     try 
     { 
       
@@ -1672,7 +1664,7 @@
    *
    * @param docid the ID of the document to be deleted from the database
    */
-  public static void delete( Connection conn, String accnum,
+  public static void delete(String accnum,
                                  String user, String[] groups )
                 throws Exception 
   {
@@ -1685,34 +1677,82 @@
     // Determine if the docid,rev are OK for DELETE
     //AccessionNumber ac = new AccessionNumber(conn);
     //docid = ac.generate(docid, rev, "DELETE");
+    DBConnection conn = null;
+    int serialNumber = -1;
+    PreparedStatement pstmt =null;
+    try
+    {
+      //check out DBConnection
+      conn=DBConnectionPool.
+                    getDBConnection("DocumentImpl.delete");
+      serialNumber=conn.getCheckOutSerialNumber();
 
-    // NEW - WHEN CLIENT ALWAYS PROVIDE ACCESSION NUMBER INCLUDING REV IN IT
-    AccessionNumber ac = new AccessionNumber(conn, accnum, "DELETE");
-    String docid = ac.getDocid();
-    String rev = ac.getRev();
+      // NEW - WHEN CLIENT ALWAYS PROVIDE ACCESSION NUMBER INCLUDING REV IN IT
+      AccessionNumber ac = new AccessionNumber(accnum, "DELETE");
+      String docid = ac.getDocid();
+      String rev = ac.getRev();
     
 
     // check for 'write' permission for 'user' to delete this document
-    if ( !hasPermission(conn, user, groups, docid) ) {
-      throw new Exception("User " + user + 
+      if ( !hasPermission(user, groups, docid) ) {
+        throw new Exception("User " + user + 
               " does not have permission to delete XML Document #" + accnum);
-    }
+      }
 
-    conn.setAutoCommit(false);
-    // Copy the record to the xml_revisions table
-    DocumentImpl.archiveDocRevision( conn, docid, user );
+      conn.setAutoCommit(false);
+      // Copy the record to the xml_revisions table
+      DocumentImpl.archiveDocRevision(conn, docid, user );
 
-    // Now delete it from the xml_documents table
-    
-    Statement stmt = conn.createStatement();
-    stmt.execute("DELETE FROM xml_index WHERE docid = '" + docid + "'");
-    //stmt.execute("DELETE FROM xml_access WHERE docid = '" + docid + "'");
-    stmt.execute("DELETE FROM xml_access WHERE accessfileid = '" + docid + "'");
-    stmt.execute("DELETE FROM xml_relation WHERE docid = '" + docid + "'");
-    stmt.execute("DELETE FROM xml_documents WHERE docid = '" + docid + "'");
-    stmt.close();
-    conn.commit();
-    conn.setAutoCommit(true);
+      // Now delete it from the xml_index table
+      pstmt = conn.prepareStatement("DELETE FROM xml_index WHERE docid = ?");
+      pstmt.setString(1,docid);
+      pstmt.execute();
+      pstmt.close();
+      conn.increaseUsageCount(1);
+      
+      //stmt.execute("DELETE FROM xml_access WHERE docid = '" + docid + "'");
+      // Now delete it from xml_access table
+      pstmt = conn.
+              prepareStatement("DELETE FROM xml_access WHERE accessfileid = ?");
+      pstmt.setString(1, docid);
+      pstmt.execute();
+      pstmt.close();
+      conn.increaseUsageCount(1);
+      
+      // Delete it from relation table
+      pstmt = conn.
+               prepareStatement("DELETE FROM xml_relation WHERE docid = ?");
+      //increase usage count
+      conn.increaseUsageCount(1);
+      pstmt.setString(1, docid);
+      pstmt.execute();
+      pstmt.close();
+      
+      // Delete it from xml_doucments table
+      pstmt =conn.prepareStatement("DELETE FROM xml_documents WHERE docid = ?");
+      pstmt.setString(1, docid);
+      pstmt.execute();
+      pstmt.close();
+      //Usaga count increase 1
+      conn.increaseUsageCount(1);
+      
+      conn.commit();
+      conn.setAutoCommit(true);
+    }//try
+    finally
+    {
+      
+      try
+      {
+        // close preparedStatement
+        pstmt.close();
+      }//try
+      finally
+      {
+        //check in DBonnection
+        DBConnectionPool.returnDBConnection(conn, serialNumber);
+      }//finally
+    }//finally
     //IF this is a package document:
     //delete all of the relations that this document created.
     //if the deleted document is a package document its relations should 
@@ -1724,13 +1764,14 @@
     * Check for "WRITE" permission on @docid for @user and/or @groups 
     * from DB connection 
     */
-  private static boolean hasPermission ( Connection conn, String user,
+  private static boolean hasPermission (String user,
                                   String[] groups, String docid ) 
                   throws SQLException, Exception
   {
     // Check for WRITE permission on @docid for @user and/or @groups
-    AccessControlList aclobj = new AccessControlList(conn);
-    return aclobj.hasPermission("WRITE", user, groups, docid);
+    //AccessControlList aclobj = new AccessControlList(dbconn);
+    return AccessControlList.hasPermission("WRITE", user, groups, docid);
+    //return aclobj.hasPermission("WRITE", user, groups, docid);
   }
 
   /** 
@@ -1740,19 +1781,20 @@
     *@group, user's group
     * 
     */
-  public boolean hasReadPermission ( Connection conn, String user,
+  public static boolean hasReadPermission (String user,
                                   String[] groups, String docId ) 
                   throws SQLException, Exception
   {
     // Check for READ permission on @docid for @user and/or @groups
-    AccessControlList aclObj = new AccessControlList(conn);
-    return aclObj.hasPermission("READ", user, groups, docId);
+    //AccessControlList aclObj = new AccessControlList(conn);
+    //return aclObj.hasPermission("READ", user, groups, docId);
+    return AccessControlList.hasPermission("READ", user, groups, docId);
   }  
 
   /**
    * Set up the parser handlers for writing the document to the database
    */
-  private static XMLReader initializeParser(Connection conn, String action,
+  private static XMLReader initializeParser(DBConnection dbconn, String action,
                                String docid, String rev, boolean validate, 
                                    String user, String[] groups, String pub, 
                                    int serverCode, Reader dtd) 
@@ -1759,16 +1801,23 @@
                            throws Exception 
   {
     XMLReader parser = null;
+    //DBConnection conn = null;
+    //int serialNumber = -1;
     //
     // Set up the SAX document handlers for parsing
     //
     try {
+       //check out DBConnection
+      /*conn=DBConnectionPool.
+                    getDBConnection("DocumentImpl.initializeParse");
+      serialNumber=conn.getCheckOutSerialNumber();*/
+      
       //create a DBSAXHandler object which has the revision specification
-      ContentHandler chandler = new DBSAXHandler(conn, action, docid, rev,
-                                                 user, groups, pub, serverCode);
-      EntityResolver eresolver= new DBEntityResolver(conn,
+      ContentHandler chandler = new DBSAXHandler(dbconn, action, 
+                                    docid, rev, user, groups, pub, serverCode);
+      EntityResolver eresolver= new DBEntityResolver(dbconn,
                                                  (DBSAXHandler)chandler, dtd);
-      DTDHandler dtdhandler   = new DBDTDHandler(conn);
+      DTDHandler dtdhandler   = new DBDTDHandler(dbconn);
 
       // Get an instance of the parser
       String parserName = MetaCatUtil.getOption("saxparser");
@@ -1795,21 +1844,99 @@
     } catch (Exception e) {
       throw e;
     }
+    //finally
+    //{
+      //DBConnectionPool.returnDBConnection(conn, serialNumber);
+    //}
 
     return parser;
   }
 
+  /**
+   * Save a document entry in the xml_revisions table 
+   * Connection use as a paramter is in order to rollback feature
+   */
+  private static void archiveDocRevision(DBConnection dbconn, String docid, 
+                                                    String user) 
+ {
+    String sysdate = dbAdapter.getDateTimeFunction();
+    //DBConnection conn = null;
+    //int serialNumber = -1;
+    PreparedStatement pstmt = null;
+    
+    // create a record in xml_revisions table 
+    // for that document as selected from xml_documents
+   
+   try
+   {
+     //check out DBConnection
+     /*conn=DBConnectionPool.
+                    getDBConnection("DocumentImpl.archiveDocRevision");
+     serialNumber=conn.getCheckOutSerialNumber();*/
+     pstmt = dbconn.prepareStatement(
+      "INSERT INTO xml_revisions " +
+        "(docid, rootnodeid, docname, doctype, " +
+        "user_owner, user_updated, date_created, date_updated, " +
+        "server_location, rev, public_access, catalog_id) " +
+      "SELECT ?, rootnodeid, docname, doctype, " + 
+        "user_owner, ?, " + sysdate + ", " + sysdate + ", "+
+        "server_location, rev, public_access, catalog_id " +
+      "FROM xml_documents " +
+      "WHERE docid = ?");
+      // Increase dbconnection usage count
+      dbconn.increaseUsageCount(1);
+      // Bind the values to the query and execute it
+      pstmt.setString(1, docid);
+      pstmt.setString(2, user);
+      pstmt.setString(3, docid);
+      pstmt.execute();
+      pstmt.close();
+   }//try
+   catch (SQLException e)
+   {
+     MetaCatUtil.debugMessage("Error in DocumentImpl.archiveDocRevision : "+
+                                e.getMessage(), 30);
+   }//catch
+   finally
+   {
+     try
+     {
+       pstmt.close();
+     }//try
+     catch (SQLException ee)
+     {
+       MetaCatUtil.debugMessage("Error in DocumnetImpl.archiveDocRevision: "+
+                                  ee.getMessage(), 50);
+     }//catch
+     //finally
+     //{
+       
+       //check in DBConnection
+       //DBConnectionPool.returnDBConnection(conn, serialNumber);
+     //}//finally
+   }//finnally
+                                  
+
+  }//achiveDocRevision
+  
   /** Save a document entry in the xml_revisions table */
-  private static void archiveDocRevision(Connection conn, String docid,
-                                         String user) 
+  private static void archiveDocRevision(String docid, String user) 
  {
     String sysdate = dbAdapter.getDateTimeFunction();
+    DBConnection conn = null;
+    int serialNumber = -1;
+    PreparedStatement pstmt = null;
+    
     // create a record in xml_revisions table 
     // for that document as selected from xml_documents
    
    try
    {
-     PreparedStatement pstmt = conn.prepareStatement(
+     //check out DBConnection
+     conn=DBConnectionPool.
+                    getDBConnection("DocumentImpl.archiveDocRevision");
+     serialNumber=conn.getCheckOutSerialNumber();
+     pstmt = conn.prepareStatement(
       "INSERT INTO xml_revisions " +
         "(docid, rootnodeid, docname, doctype, " +
         "user_owner, user_updated, date_created, date_updated, " +
@@ -1825,27 +1952,73 @@
       pstmt.setString(3, docid);
       pstmt.execute();
       pstmt.close();
-   }
+   }//try
    catch (SQLException e)
    {
-   }
-   
+     MetaCatUtil.debugMessage("Error in DocumentImpl.archiveDocRevision : "+
+                                e.getMessage(), 30);
+   }//catch
+   finally
+   {
+     try
+     {
+       pstmt.close();
+     }//try
+     catch (SQLException ee)
+     {
+       MetaCatUtil.debugMessage("Error in DocumnetImpl.archiveDocRevision: "+
+                                  ee.getMessage(), 50);
+     }//catch
+     finally
+     {
+       //check in DBConnection
+       DBConnectionPool.returnDBConnection(conn, serialNumber);
+     }//finally
+   }//finnally
+                                  
 
-  }
+  }//achiveDocRevision
   
   /**
     * delete a entry in xml_table for given docid
     * @param docId, the id of the document need to be delete
     */
-  private static void deleteXMLDocuments(Connection conn, String docId) 
+  private static void deleteXMLDocuments(String docId) 
                                          throws SQLException 
   {
-    //delete a record 
-    PreparedStatement pStmt = 
+    DBConnection conn = null;
+    int serialNumber = -1;
+    PreparedStatement pStmt = null;
+    try
+    {
+      //check out DBConnection
+      conn=DBConnectionPool.
+                    getDBConnection("DocumentImpl.deleteXMLDocuments");
+      serialNumber=conn.getCheckOutSerialNumber();
+      //delete a record 
+      pStmt = 
              conn.prepareStatement("DELETE FROM xml_documents WHERE docid = '" 
                                               + docId + "'");
     pStmt.execute();
-    pStmt.close();
+    }//try
+    finally
+    {
+      try
+      {
+        pStmt.close();
+      }//try
+      catch (SQLException e)
+      {
+        MetaCatUtil.debugMessage("error in DocumentImpl.deleteXMLDocuments: "+
+                                  e.getMessage(), 50);
+      }//catch
+      finally
+      {
+        //return back DBconnection
+        DBConnectionPool.returnDBConnection(conn, serialNumber);
+      }//finally
+    }//finally
+      
 
   }//deleteXMLDocuments
   
@@ -1855,28 +2028,54 @@
     * The return value is integer because we want compare it to there new one
     * @param docid <sitecode>.<uniqueid> part of Accession Number
     */
-  private static int getLatestRevisionNumber(Connection conn, String docId)
+  private static int getLatestRevisionNumber(String docId)
                                       throws SQLException
   {
     int rev = 1;
-    PreparedStatement pStmt;
+    PreparedStatement pStmt = null;
+    DBConnection dbConn = null;
+    int serialNumber = -1;
+    
+    try
+    {
+      //check out DBConnection
+      dbConn=DBConnectionPool.
+                    getDBConnection("DocumentImpl.getLatestRevisionNumber");
+      serialNumber=dbConn.getCheckOutSerialNumber();
      
-    pStmt = conn.prepareStatement
+      pStmt = dbConn.prepareStatement
               ("SELECT rev FROM xml_documents WHERE docid='" + docId + "'");
-    pStmt.execute();
+      pStmt.execute();
 
-    ResultSet rs = pStmt.getResultSet();
-    boolean hasRow = rs.next();
-    if (hasRow)
+      ResultSet rs = pStmt.getResultSet();
+      boolean hasRow = rs.next();
+      if (hasRow)
+      {
+        rev = rs.getInt(1);
+        pStmt.close();
+      }
+      else
+      {
+        rev=-1;
+        pStmt.close();
+      }
+    }//try
+    finally
     {
-      rev = rs.getInt(1);
-      pStmt.close();
-    }
-    else
-    {
-      rev=-1;
-      pStmt.close();
-    }
+      try
+      {
+        pStmt.close();
+      }
+      catch (Exception ee)
+      {
+        MetaCatUtil.debugMessage("Error in DocumentImpl."+
+                        "getLatestRevisionNumber: "+ee.getMessage(), 50);
+      }
+      finally
+      {
+        DBConnectionPool.returnDBConnection(dbConn, serialNumber);
+      }
+    }//finally  
       
     return rev;
   }//getLatestRevisionNumber
@@ -1886,33 +2085,59 @@
    * 
    * @param accum <sitecode>.<uniqueid>.<rev>
    */
-  private static int getServerLocationNumber(Connection conn, String accNum)
+  private static int getServerLocationNumber(String accNum)
                                             throws SQLException
   {
     //get rid of revNum part
     String docId=MetaCatUtil.getDocIdFromString(accNum);
-    PreparedStatement pStmt;
-    int serverLocation;
+    PreparedStatement pStmt = null;
+    int serverLocation = 1;
+    DBConnection conn = null;
+    int serialNumber = -1;
+    
+    try
+    {
+      //check out DBConnection
+      conn=DBConnectionPool.
+                    getDBConnection("DocumentImpl.getServerLocationNumber");
+      serialNumber=conn.getCheckOutSerialNumber();
      
-    pStmt = conn.prepareStatement
+      pStmt = conn.prepareStatement
       ("SELECT server_location FROM xml_documents WHERE docid='" + docId + "'");
-    pStmt.execute();
+      pStmt.execute();
 
-    ResultSet rs = pStmt.getResultSet();
-    boolean hasRow = rs.next();
-    //if there is entry in xml_documents, get the serverlocation
-    if (hasRow)
+      ResultSet rs = pStmt.getResultSet();
+      boolean hasRow = rs.next();
+      //if there is entry in xml_documents, get the serverlocation
+      if (hasRow)
+      {
+        serverLocation = rs.getInt(1);
+        pStmt.close();
+      }
+      else
+      {
+        //if htere is no entry in xml_documents, we consider it is new document
+        //the server location is local host and value is 1
+        serverLocation=1;
+        pStmt.close();
+      }
+    }//try
+    finally
     {
-      serverLocation = rs.getInt(1);
-      pStmt.close();
-    }
-    else
-    {
-      // if htere is no entry in xml_documents, we consider it is new document
-      // the server location is local host and value is 1
-      serverLocation=1;
-      pStmt.close();
-    }
+      try
+      {
+        pStmt.close();
+      }//try
+      catch (Exception ee)
+      {
+        MetaCatUtil.debugMessage("Error in DocumentImpl.getServerLocationNu(): "
+                                    +ee.getMessage(), 50);
+      }//catch
+      finally
+      {
+        DBConnectionPool.returnDBConnection(conn, serialNumber);
+      }//finally
+    }//finally
       
     return serverLocation;
   }
@@ -1926,12 +2151,13 @@
   {
     PreparedStatement pStmt=null;
     int serverLocation=-2;
-    Connection dbConn = null;
-    MetaCatUtil util = new MetaCatUtil();
+    DBConnection dbConn = null;
+    int serialNumber = -1;
+    //MetaCatUtil util = new MetaCatUtil();
     
     
     //we should consider about local host too
-    if (serverName.equals(util.getLocalReplicationServerName()))
+    if (serverName.equals(MetaCatUtil.getLocalReplicationServerName()))
     { 
       serverLocation=1;
       return serverLocation;
@@ -1941,7 +2167,10 @@
     try
     {
       //check xml_replication table
-      dbConn=util.openDBConnection();
+      //dbConn=util.openDBConnection();
+      //check out DBConnection
+      dbConn=DBConnectionPool.getDBConnection("DocumentImpl.getServerCode");
+      serialNumber=dbConn.getCheckOutSerialNumber();
       pStmt = dbConn.prepareStatement
       ("SELECT serverid FROM xml_replication WHERE server='" + serverName +"'");
       pStmt.execute();
@@ -1963,7 +2192,7 @@
     }
     catch (Exception e)
     {
-      util.debugMessage("Error in DocumentImpl.getServerCode(): "
+      MetaCatUtil.debugMessage("Error in DocumentImpl.getServerCode(): "
                                     +e.getMessage(), 30);
     }
     finally
@@ -1970,10 +2199,17 @@
     {
       try
       {
-        dbConn.close();
+        pStmt.close();
       }
       catch (Exception ee)
-      {}
+      {
+        MetaCatUtil.debugMessage("Error in DocumentImpl.getServerCode(): "
+                                    +ee.getMessage(), 50);
+      }
+      finally
+      {
+        DBConnectionPool.returnDBConnection(dbConn, serialNumber);
+      }
     }
                  
       
@@ -1987,12 +2223,17 @@
   private static void  insertServerIntoReplicationTable(String server)
   {
     PreparedStatement pStmt=null;
-    Connection dbConn = null;
+    DBConnection dbConn = null;
+    int serialNumber = -1;
     int replicate = 1;
-    MetaCatUtil util = new MetaCatUtil();
+    //MetaCatUtil util = new MetaCatUtil();
     try
     {
-       dbConn=util.openDBConnection();
+       //dbConn=util.openDBConnection();
+       //check out DBConnection
+       dbConn=DBConnectionPool.
+                getDBConnection("DocumentImpl.insertServIntoReplicationTable");
+       serialNumber=dbConn.getCheckOutSerialNumber();
        pStmt = dbConn.prepareStatement("INSERT INTO xml_replication " +
                                       "(server, last_checked, replicate) " +
                                       "VALUES ('" + server + "', to_date(" +
@@ -2001,22 +2242,30 @@
         pStmt.execute();
         pStmt.close();
         dbConn.commit();
-    }
+    }//try
     catch (Exception e)
     {
-      util.debugMessage("Error in DocumentImpl.getServerCode(): "
+      MetaCatUtil.debugMessage("Error in DocumentImpl.insertServerIntoRepli(): "
                                     +e.getMessage(), 30);
-    }
+    }//catch
     finally
     {
+     
       try
       {
         pStmt.close();
-        dbConn.close();
+      }//try
+      catch (Exception ee)
+      {
+        MetaCatUtil.debugMessage("Error in DocumentImpl.insetServerIntoRepl(): "
+                                    +ee.getMessage(), 50);
+      }//catch
+      finally
+      {
+        DBConnectionPool.returnDBConnection(dbConn, serialNumber);
       }
-      catch (Exception ee)
-      {}
-    }
+    
+    }//finally
 
   }
   
@@ -2031,7 +2280,8 @@
    * @param docid the id of the document to process
    */
   static public void main(String[] args) {
-     
+    DBConnection dbconn = null;
+    int serialNumber = -1;
     try {
       String filename    = null;
       String dtdfilename = null;
@@ -2103,12 +2353,14 @@
       
       // Open a connection to the database
       MetaCatUtil util = new MetaCatUtil();
-      Connection dbconn = util.openDBConnection();
+     
+      dbconn=DBConnectionPool.getDBConnection("DocumentImpl.main");
+      serialNumber=dbconn.getCheckOutSerialNumber();
 
       double connTime = System.currentTimeMillis();
       // Execute the action requested (READ, INSERT, UPDATE, DELETE)
       if (action.equals("READ")) {
-          DocumentImpl xmldoc = new DocumentImpl( dbconn, docid );
+          DocumentImpl xmldoc = new DocumentImpl(docid );
           if (useOldReadAlgorithm) {
             System.out.println(xmldoc.readUsingSlowAlgorithm());
           } else {
@@ -2115,7 +2367,7 @@
             xmldoc.toXml(new PrintWriter(System.out));
           }
       } else if (action.equals("DELETE")) {
-        DocumentImpl.delete(dbconn, docid, null, null);
+        DocumentImpl.delete(docid, null, null);
         System.out.println("Document deleted: " + docid);
       } else {
         String newdocid = DocumentImpl.write(dbconn, filename, null,
@@ -2156,5 +2408,10 @@
       System.err.println(e.getMessage());
       e.printStackTrace(System.err);
     }
+    finally
+    {
+      // Return db connection
+      DBConnectionPool.returnDBConnection(dbconn, serialNumber);
+    }
   }
 }
Index: src/edu/ucsb/nceas/metacat/DBEntityResolver.java
===================================================================
--- src/edu/ucsb/nceas/metacat/DBEntityResolver.java	(revision 1216)
+++ src/edu/ucsb/nceas/metacat/DBEntityResolver.java	(revision 1217)
@@ -52,7 +52,7 @@
  */
 public class DBEntityResolver implements EntityResolver
 {
-  private Connection conn = null;
+  private DBConnection connection = null;
   private DefaultHandler handler = null;
   private String docname = null;
   private String doctype = null;
@@ -64,9 +64,9 @@
    *
    * @param conn the JDBC connection to which information is written
    */
-  public DBEntityResolver(Connection conn)
+  public DBEntityResolver(DBConnection conn)
   {
-    this.conn = conn;
+    this.connection= conn;
   }
   /** 
    * Construct an instance of the DBEntityResolver class
@@ -75,9 +75,9 @@
    * @param handler the SAX handler to determine parsing context
    * @param dtd Reader of new dtd to be uploaded on server's file system
    */
-  public DBEntityResolver(Connection conn, DefaultHandler handler, Reader dtd)
+  public DBEntityResolver(DBConnection conn, DefaultHandler handler, Reader dtd)
   {
-    this.conn = conn;
+    this.connection = conn;
     this.handler = handler;
     this.dtdtext = dtd;
   }
@@ -185,8 +185,14 @@
                  throws SAXException
   {
     String systemid = null;
-    Statement stmt;
+    Statement stmt = null;
+    DBConnection conn = null;
+    int serialNumber = -1;
     try {
+      //check out DBConnection
+      conn=DBConnectionPool.getDBConnection("DBEntityResolver.getDTDSystemID");
+      serialNumber=conn.getCheckOutSerialNumber();
+      
       stmt = conn.createStatement();
       stmt.execute("SELECT system_id FROM xml_catalog " + 
                    "WHERE entry_type = 'DTD' AND public_id = '" +
@@ -201,6 +207,22 @@
       throw new SAXException
       ("DBEntityResolver.getDTDSystemID(): " + e.getMessage());
     }
+    finally
+    {
+      try
+      {
+        stmt.close();
+      }//try
+      catch (SQLException sqlE)
+      {
+        MetaCatUtil.debugMessage("Error in DBEntityReolver.getDTDSystemId: "
+                                  +sqlE.getMessage(), 30);
+      }//catch
+      finally
+      {
+        DBConnectionPool.returnDBConnection(conn, serialNumber);
+      }//finally
+    }//finally
 
     // return the selected System ID
     return systemid;
@@ -213,13 +235,22 @@
   private void registerDTD ( String doctype, String systemId )
                  throws SAXException
   {
+    //DBConnection conn = null;
+    //int serialNumber = -1;
+    PreparedStatement pstmt = null;
     // make a reference in db catalog table with @systemId for @doctype
     try {
-      PreparedStatement pstmt;
-      pstmt = conn.prepareStatement(
+      //check out DBConnection
+      //conn=DBConnectionPool.getDBConnection("DBEntityResolver.registerDTD");
+      //serialNumber=conn.getCheckOutSerialNumber();
+      
+      
+      pstmt = connection.prepareStatement(
              "INSERT INTO xml_catalog " +
              "(catalog_id, entry_type, public_id, system_id) " +
              "VALUES (null, 'DTD', ?, ?)");
+      // Increase usage count
+      connection.increaseUsageCount(1);
       // Bind the values to the query
       pstmt.setString(1, doctype);
       pstmt.setString(2, systemId);
@@ -230,6 +261,20 @@
       throw new SAXException
       ("DBEntityResolver.registerDTD(): " + e.getMessage());
     }
+    finally
+    {
+      try
+      {
+        pstmt.close();
+      }//try
+      catch (SQLException sqlE)
+      {
+        MetaCatUtil.debugMessage("Error in DBEntityReolver.registerDTD: "
+                                    +sqlE.getMessage(), 30);
+      }//catch
+      //DBConnectionPool.returnDBConnection(conn, serialNumber);
+    }//finally
+    
   }
 
   /** 
